<template>
  <main class="SettingsView">
    <div class="SettingsView__Fields">
      <RadioButton
        v-model="settings.lang"
        :label="t('settings.language')"
        :options="langOptions"
        :restoreValue="savedSettings.lang"
        class="SettingsView__Languages"
        noTranslate
      />

      <RadioButton
        v-model="settings.theme"
        :label="t('settings.theme')"
        :options="themeOptions"
        :restoreValue="savedSettings.theme"
        class="SettingsView__Themes"
      />

      <RadioButton
        v-model="settings.downloadFormat"
        :label="t('settings.downloadFormat')"
        :options="downloadFormatOptions"
        :restoreValue="savedSettings.downloadFormat"
        no-translate
        class="SettingsView__DownloadFormats"
      />
    </div>

    <div class="SettingsView__Controls">
      <Button
        :disabled="defaultSettings"
        :icon="Icons.reset"
        :label="t('settings.reset')"
        class="SettingsView__ResetButton"
        @click="reset"
      />
      <Button
        :disabled="pristine"
        :icon="Icons.restore"
        :iconLeft="true"
        :label="t('settings.restore')"
        class="SettingsView__RestoreButton"
        @click="restore"
      />
    </div>
  </main>
</template>

<script lang="ts">
import { computed, defineComponent, inject } from 'vue'
import { Button, RadioButton } from '@/components'
import { DEFAULT_SETTINGS, settings } from '@/states'
import { Icons } from '@/Icons'
import { States } from '@/types'
import { Translations } from '@/lang'

export default defineComponent({
  name: 'view/Settings',
  components: { RadioButton, Button },

  setup() {
    const savedSettingsJson = JSON.stringify(settings)
    const savedSettings = JSON.parse(savedSettingsJson)

    // Copy settings for restore options
    const pristine = computed(
      () => savedSettingsJson === JSON.stringify(settings)
    )
    const defaultSettings = computed(
      () => JSON.stringify(settings) === JSON.stringify(DEFAULT_SETTINGS)
    )

    // Import translator
    const t = inject('t', (str: unknown) => str)

    // Get all available languages
    const messages: Record<string, Translations> = inject('messages', {
      value: {},
    }).value

    const langOptions: Record<string, string> = {
      [t(States.SAME_AS_BROWSER) as string]: States.SAME_AS_BROWSER,
    }

    for (const lang of Object.keys(messages)) {
      if (messages[lang]) langOptions[messages[lang]._name] = lang
    }

    const themeOptions: Record<string, States.Settings['theme']> = {
      'settings.light': 'themeLight',
      'settings.dark': 'themeDark',
      [States.SAME_AS_BROWSER]: States.SAME_AS_BROWSER,
    }

    const downloadFormatOptions: Record<
      string,
      States.Settings['downloadFormat']
    > = {
      Yaml: 'yaml',
      Json: 'json',
      CSV: 'csv',
    }

    return {
      Icons,
      pristine,
      defaultSettings,
      savedSettings,
      restore: () => Object.assign(settings, JSON.parse(savedSettingsJson)),
      settings,
      t,
      downloadFormatOptions,
      langOptions,
      themeOptions,
      reset: () => Object.assign(settings, DEFAULT_SETTINGS),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;
@use '../style/view';

.SettingsView {
  @extend .View;

  &__Fields > * {
    background-color: var(--background-color);
  }

  &__Controls {
    display: flex;
    align-items: center;
    justify-items: flex-start;
    padding: v.$spacing;
  }

  &__DownloadFormats {
    display: inline-flex;
  }
}
</style>
